<?php

namespace App\Controllers;

class Asset extends BaseController
{
    public function index()
    {
        $id=session()->get('id');
        if($id){
            return view('Asset/add_asset');
        }else{
            return redirect()->to('/');
        }
    }
    public function add_asset_form()
    {
        $data=$this->request->getVar();
        $data['created_at']=date('Y-m-d H:i:s');
        $data['created_by']=session()->get('username');
        $purchase_bill = $this->request->getFile('purchase_bill');
        if ($purchase_bill->isValid() && !$purchase_bill->hasMoved()) {
            $newNamepurchase_bill = uniqid() . '.' . $purchase_bill->getClientExtension();
            $purchase_bill->move('public/assets/asset_management', $newNamepurchase_bill);
        } else {
            
            return $this->response->setJSON(['result' => 0, 'message' => 'Failed to upload purchase bill']);
            // exit();
        }
        $data['purchase_bill']=$newNamepurchase_bill;

        $upload_document = $this->request->getFile('upload_document');
        if ($upload_document->isValid() && !$upload_document->hasMoved()) {
            $newNameupload_document = uniqid() . '.' . $upload_document->getClientExtension();
            $upload_document->move('public/assets/asset_management', $newNameupload_document);
        } else {
            
            return $this->response->setJSON(['result' => 0, 'message' => 'Failed to upload document']);
            // exit();
        }
        $data['upload_document']=$newNameupload_document;

        $agreement_document = $this->request->getFile('agreement_document');
        if ($agreement_document->isValid() && !$agreement_document->hasMoved()) {
            $newNameagreement_document = uniqid() . '.' . $agreement_document->getClientExtension();
            $agreement_document->move('public/assets/asset_management', $newNameagreement_document);
        } else {
            
            return $this->response->setJSON(['result' => 0, 'message' => 'Failed to agreement document']);
            // exit();
        }
        $data['agreement_document']=$newNameagreement_document;
        
        $db=\Config\Database::connect();

        $builder=$db->table('asset');
        $insert=$builder->insert($data);
        if($insert){
            return $this->response->setJSON(['result'=>1,'message'=>'Asset Added Successfully']);
        }else{
            return $this->response->setJSON(['result'=>0,'message'=>'Asset Added failed']);
        }

    }
    public function update_asset_form()
    {
        $db = \Config\Database::connect();
        $data = $this->request->getVar();
        $sid = $this->request->getVar('id');
        $data['created_at'] = date('Y-m-d H:i:s');
        $data['created_by'] = session()->get('username');
    
        $purchase_bill = $this->request->getFile('purchase_bill');
        if ($purchase_bill->isValid() && !$purchase_bill->hasMoved()) {
            $newNamepurchase_bill = uniqid() . '.' . $purchase_bill->getClientExtension();
            $purchase_bill->move('public/assets/asset_management', $newNamepurchase_bill);
            $data['purchase_bill'] = $newNamepurchase_bill;
        } else {
            $imagename = $db->table('asset')->select('purchase_bill')->where('id', $sid)->get()->getRowArray();
            $data['purchase_bill'] = $imagename['purchase_bill'];
        }
    
        $upload_document = $this->request->getFile('upload_document');
        if ($upload_document->isValid() && !$upload_document->hasMoved()) {
            $newNameupload_document = uniqid() . '.' . $upload_document->getClientExtension();
            $upload_document->move('public/assets/asset_management', $newNameupload_document);
            $data['upload_document'] = $newNameupload_document;
        } else {
            $imagename = $db->table('asset')->select('upload_document')->where('id', $sid)->get()->getRowArray();
            $data['upload_document'] = $imagename['upload_document'];
        }
    
        $agreement_document = $this->request->getFile('agreement_document');
        if ($agreement_document->isValid() && !$agreement_document->hasMoved()) {
            $newNameagreement_document = uniqid() . '.' . $agreement_document->getClientExtension();
            $agreement_document->move('public/assets/asset_management', $newNameagreement_document);
            $data['agreement_document'] = $newNameagreement_document;
        } else {
            $imagename = $db->table('asset')->select('agreement_document')->where('id', $sid)->get()->getRowArray();
            $data['agreement_document'] = $imagename['agreement_document'];
        }
    
        $builder = $db->table('asset');
        $update = $builder->where('id', $sid)->update($data);
    
        if ($update) {
            return $this->response->setJSON(['result' => 1, 'message' => 'Asset updated successfully']);
        } else {
            return $this->response->setJSON(['result' => 0, 'message' => 'Asset update failed']);
        }
    }
    

    public function asset_list()
    {
        $id=session()->get('id');
        if($id){
            return view('Asset/asset_list');
        }else{
            return redirect()->to('/');
        }
    }
    public function asset_list_data()
    {
        $id=session()->get('id');
        if($id){
            $db = \Config\Database::connect();
            $builder = $db->table('asset');
   
            $data = $builder->get()->getResultArray();
       
            // print_r($data);die();
            if($data){
                return $this->response->setJSON($data);
            }else{
                return $this->response->setJSON(['result'=>0,'message'=>'Failed to load data']);
            }
        }else{
            // echo 'hello';die();
            return $this->response->setJSON(['result'=>0,'message'=>'please login']);
        }
    }
    public function asset_delete()
    {
        $id=$this->request->getVar('id');
        // echo $id;die();
        $db=\Config\Database::connect();
        $builder=$db->table('asset');
        $builder->where('id',$id);
        $delete=$builder->delete();
        if($delete){
            return $this->response->setJSON(['result'=>1]);
        }else{
            return $this->response->setJSON(['result'=>0]);
        }
    }

    public function asset_edit()
    {
        $id=session()->get('id');
        if($id){
            $sid=$this->request->getVar('id');
            // echo $sid;die();
            $db=\Config\Database::connect();
            $builder=$db->table('asset');
            $builder->where('id',$sid);
            $data=$builder->get()->getRowArray();
            // print_r($data);die();
            // $data['value']=$data;
            return view('Asset/edit_asset',$data);
        }else{
            return $this->response->setJSON(['result'=>0,'message'=>'please login']);
        }
    }
}
?>